rte_swx_extern.h(3)

NAME
rte_swx_extern.h

SYNOPSIS

#include <stdint.h>

  Typedefs

typedef void *(* rte_swx_extern_type_constructor_t) (const char *args)
typedef void(* rte_swx_extern_type_destructor_t) (void *object)
typedef int(* rte_swx_extern_type_member_func_t) (void *object, void *mailbox)
typedef int(* rte_swx_extern_func_t) (void *mailbox)

Detailed Description

RTE SWX Extern objects and functions

Extern object and extern function interfaces. The extern objects and extern functions provide the mechanisms to hook external functionality into the packet processing pipeline.

Definition in file rte_swx_extern.h.

Typedef Documentation

  typedef void *(* rte_swx_extern_type_constructor_t) (const char *args)
Extern object constructor

Parameters
    args Extern object constructor arguments. It may be NULL.

Returns
    Extern object handle.

Definition at line 30 of file rte_swx_extern.h.

  typedef void(* rte_swx_extern_type_destructor_t) (void *object)
Extern object destructor

Parameters
    object Extern object handle.

Definition at line 39 of file rte_swx_extern.h.

  typedef int(* rte_swx_extern_type_member_func_t) (void *object, void *mailbox)
Extern object member function

The mailbox is used to pass input arguments to the member function and retrieve the output results. The mailbox mechanism allows for multiple concurrent executions of the same member function for the same extern object.

Multiple invocations of the same member function may be required in order for the associated operation to complete. The completion is flagged by a return value of 1, in which case the results are available in the mailbox; in case of a return value of 0, the operation is not yet completed, so the member function must be invoked again with exactly the same object and mailbox arguments.

Parameters
    object Extern object handle.
    mailbox Extern object mailbox.

Returns
    0 when the operation is not yet completed, and 1 when the operation is completed. No other return values are allowed.

Definition at line 64 of file rte_swx_extern.h.

  typedef int(* rte_swx_extern_func_t) (void *mailbox)
The mailbox is used to pass input arguments to the extern function and retrieve the output results. The mailbox mechanism allows for multiple concurrent executions of the same extern function.

Multiple invocations of the same extern function may be required in order for the associated operation to complete. The completion is flagged by a return value of 1, in which case the results are available in the mailbox; in case of a return value of 0, the operation is not yet completed, so the extern function must be invoked again with exactly the same mailbox argument.

Parameters
    mailbox Extern object mailbox.

Returns
    0 when the operation is not yet completed, and 1 when the operation is completed. No other return values are allowed.

Definition at line 87 of file rte_swx_extern.h.

Author

Generated automatically by Doxygen for DPDK from the source code.